diff a/test/jdk/tools/jlink/plugins/CDSPluginTest.java b/test/jdk/tools/jlink/plugins/CDSPluginTest.java
--- a/test/jdk/tools/jlink/plugins/CDSPluginTest.java
+++ b/test/jdk/tools/jlink/plugins/CDSPluginTest.java
@@ -24,10 +24,11 @@
 import java.io.File;
 
 import jdk.test.lib.JDKToolFinder;
 import jdk.test.lib.Platform;
 import jdk.test.lib.process.*;
+import jdk.test.whitebox.WhiteBox;
 
 import tests.Helper;
 
 import jtreg.SkippedException;
 
@@ -42,11 +43,13 @@
  *          jdk.jlink/jdk.tools.jlink.internal
  *          jdk.jlink/jdk.tools.jmod
  *          jdk.jlink/jdk.tools.jimage
  *          jdk.compiler
  * @build tests.*
- * @run main CDSPluginTest
+ * @build jdk.test.whitebox.WhiteBox
+ * @run driver jdk.test.lib.helpers.ClassFileInstaller jdk.test.whitebox.WhiteBox
+ * @run main/othervm -XX:+UnlockDiagnosticVMOptions -XX:+WhiteBoxAPI -Xbootclasspath/a:. CDSPluginTest
  */
 
 public class CDSPluginTest {
 
     public static void main(String[] args) throws Throwable {
@@ -73,14 +76,19 @@
         } else {
             subDir = "lib" + sep;
         }
         subDir += "server" + sep;
 
+        boolean COMPACT_HEADERS =
+                Platform.is64bit() && WhiteBox.getWhiteBox().getBooleanVMFlag("UseCompactObjectHeaders");
+
+        String suffix = COMPACT_HEADERS ? "_coh.jsa" : ".jsa";
+
         if (Platform.isAArch64() || Platform.isX64()) {
             helper.checkImage(image, module, null, null,
-                      new String[] { subDir + "classes.jsa", subDir + "classes_nocoops.jsa" });
+                      new String[] { subDir + "classes" + suffix, subDir + "classes_nocoops" + suffix });
         } else {
             helper.checkImage(image, module, null, null,
-                      new String[] { subDir + "classes.jsa" });
+                      new String[] { subDir + "classes" + suffix });
         }
     }
 }
